// ADT7410使用温度センサモジュール用ライブラリ ソースファイル

#include <arduino.h>
#include <Wire.h>
#include "ADT7410.h"


//コンストラクタを定義
ADT7410::ADT7410()
{  
}


// 温度センサモジュールADT7410を初期化する関数(16bitモード）
void ADT7410::initADT7410(int adrs){
  Wire.beginTransmission(adrs);  // アドレスのI2Cスレーブに対して送信処理を開始
  Wire.write(0x03);                 // Configuration register(0x03) 選択
  Wire.write(0x80);                 // 分解能16bitに設定 1000 0000
  Wire.endTransmission();           // スレーブデバイスに対する送信を完了
}


// 温度センサモジュールADT7410の温度測定値を取得する関数(16bitモード)
float ADT7410::gettmp(int adrs){
  unsigned int val; // 2バイトの正の値
  float tmp;

  Wire.requestFrom(adrs, 2);       // S.C発行,CB送信 (アドレス,要求するデータのバイト数)
  val = Wire.read() << 8;             // データの読み出し(上位8bit)
  val = val | Wire.read();            // データの読み出し(下位8bit)
  
  tmp = (float)val / 128.0;         // 摂氏温度換算 1/128= 2^(-7) = 0.0078125
 
  if(val & 0x8000) {                // 符号判定 16bitの先頭が1なら負
    val = val  - 0x8000;            // 負数のとき
    tmp = (float)val / 128.0 * -1;// -1倍する
  }
  
  return tmp;
}


